Codeforces Round #379 (Div. 2) -- C. Anton and Making Potions(简单的分类讨论 + 二分)

大体题意:

你要制作n 个药水,正常情况下 是x秒能造1瓶,但为了节省时间,你有两种方式来加速!

一种是花费一定数量的金币 来获得速度,  会改变制造一瓶的时间 ,另一种 会瞬间得到 一定量的药水!

你有s 金币,告诉你每一类的每一个的花费。求最少时间!  每一类最多用一个魔法!

思路:

简单模拟一下就行了!

为了不漏解,分四种情况讨论!

1. 两种全不用  直接是x 秒1瓶!这个很简单!

2. 第一种用 第二种不用,  第一种既然用 那肯定找一个速度最快 且能买到的方式  ,排个序找一个 合适的价格就行!也比较简单。

3. 第一种不用,第二种用,  直接找一个生产的最多  且 能买的就行  也很简单!

4. 两种全用,  我们可以枚举第一种用哪一个,  剩下的钱 二分 第二种, 因为第二种保证了  数量和价格都是非递减的,可以二分!

这样  都讨论完全了。

#include <bits/stdc++.h>
#define ps push_back
#define fi first
#define se second
#define mr make_pair
using namespace std;
typedef long long ll;
typedef unsigned long long LLU;
const int inf = 0x3f3f3f3f;
const double eps = 1e-10;
const double pi = acos(-1.0);
char s[100000 + 7];
struct node1{
    int t,mon;
    bool operator < (const node1& rhs) const {
        return t < rhs.t;
    }
}p[200000+7];
int c[200000+7],d[200000 + 7];

int main(){
//    int a[] = {1,1,2,2,3,5};
//    int mm = upper_bound(a,a+6,4) - a;
//    cout<<mm<<endl;
    int n,m,k;
    scanf("%d %d %d",&n,&m,&k);
    int x,s;
    scanf("%d %d",&x,&s);
    for (int i = 0; i < m; ++i){
        scanf("%d",&p[i].t);
    }
    for (int i = 0; i < m; ++i){
        scanf("%d",&p[i].mon);
    }
//    for (int i = 0; i < k; ++i){
//        scanf("%d",&p2[i].num);
//    }
    for (int i = 0; i < k; ++i){
        scanf("%d",&c[i]);
    }
    for (int i = 0; i < k; ++i){
        scanf("%d",&d[i]);
    }
    ll sum = (ll)n*(ll)x;
    for (int i = k-1; ~i; --i){
        if (s >= d[i]){
            ll tmp = 0;
            if (n > c[i]){
                tmp += (ll)(n-c[i]) * x;
            }
            sum = min(sum,tmp);
            break;
        }
    }
    sort(p,p+m);
    for (int i = 0; i < m; ++i){
        if (s >= p[i].mon){
            sum = min(sum,(ll)n*(ll)p[i].t);
            break;
        }
    }
    if (!sum){
        printf("%lld\n",sum);
        return 0;
    }
    for (int i = 0; i < m; ++i){
        ll tmp = 0;
        if (s >= p[i].mon){
            int s2 = s - p[i].mon;
            int pos = upper_bound(d,d+k,s2) - d;
            if (pos == 0)continue;
            tmp += c[pos-1];
            sum = min(sum,(ll)(n-tmp)*(ll)p[i].t );
        }

    }
    printf("%lld\n",sum);
    return 0;
}

C. Anton and Making Potions
time limit per test
4 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Anton is playing a very interesting computer game, but now he is stuck at one of the levels. To pass to the next level he has to prepare npotions.

Anton has a special kettle, that can prepare one potions in x seconds. Also, he knows spells of two types that can faster the process of preparing potions.

  1. Spells of this type speed up the preparation time of one potion. There are m spells of this type, the i-th of them costs bi manapoints and changes the preparation time of each potion to ai instead of x.
  2. Spells of this type immediately prepare some number of potions. There are k such spells, the i-th of them costs di manapoints and instantly create ci potions.

Anton can use no more than one spell of the first type and no more than one spell of the second type, and the total number of manapoints spent should not exceed s. Consider that all spells are used instantly and right before Anton starts to prepare potions.

Anton wants to get to the next level as fast as possible, so he is interested in the minimum number of time he needs to spent in order to prepare at least n potions.

Input

The first line of the input contains three integers nmk (1 ≤ n ≤ 2·109, 1 ≤ m, k ≤ 2·105) — the number of potions, Anton has to make, the number of spells of the first type and the number of spells of the second type.

The second line of the input contains two integers x and s (2 ≤ x ≤ 2·109, 1 ≤ s ≤ 2·109) — the initial number of seconds required to prepare one potion and the number of manapoints Anton can use.

The third line contains m integers ai (1 ≤ ai < x) — the number of seconds it will take to prepare one potion if the i-th spell of the first type is used.

The fourth line contains m integers bi (1 ≤ bi ≤ 2·109) — the number of manapoints to use the i-th spell of the first type.

There are k integers ci (1 ≤ ci ≤ n) in the fifth line — the number of potions that will be immediately created if the i-th spell of the second type is used. It's guaranteed that ci are not decreasing, i.e. ci ≤ cj if i < j.

The sixth line contains k integers di (1 ≤ di ≤ 2·109) — the number of manapoints required to use the i-th spell of the second type. It's guaranteed that di are not decreasing, i.e. di ≤ dj if i < j.

Output

Print one integer — the minimum time one has to spent in order to prepare n potions.

Examples
input
20 3 2
10 99
2 4 3
20 10 40
4 15
10 80
output
20
input
20 3 2
10 99
2 4 3
200 100 400
4 15
100 800
output
200
Note

In the first sample, the optimum answer is to use the second spell of the first type that costs 10 manapoints. Thus, the preparation time of each potion changes to 4 seconds. Also, Anton should use the second spell of the second type to instantly prepare 15 potions spending 80 manapoints. The total number of manapoints used is 10 + 80 = 90, and the preparation time is 4·5 = 20 seconds (15potions were prepared instantly, and the remaining 5 will take 4 seconds each).

In the second sample, Anton can't use any of the spells, so he just prepares 20 potions, spending 10 seconds on each of them and the answer is 20·10 = 200.


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值